#include"defs.h"

int position[36][4];

int fingering[5][12]={
  {0,1,-1,2,3,4,-1,-1,-1,-1,-1,-1},
  {0,-1,1,2,3,4,-1,-1,-1,-1,-1,-1},
  {0,-1,-1,1,2,3,4,-1,-1,-1,-1,-1},
  {0,-1,-1,-1,-1,1,2,3,4,-1,-1,-1},
  {0,-1,-1,-1,-1,-1,1,-1,2,3,4,-1}
};

void posgen() {
  int i,j;
  for(i=0;i<4;i++)
    for(j=0;j<36;j++)
      position[j][i]=-1;
  for(i=0;i<4;i++)
    for(j=0;j<12;j++)
      position[j+7*i][i]=j;
}

/* key hardcoded to Eb*/
int tone(int oct, char let, int bump) {
  int letoff;
  switch (let) {
  case 'C': letoff=0;break;
  case 'D': letoff=2;break;
  case 'E': letoff=4-1;break;
  case 'F': letoff=5;break;
  case 'G': letoff=7;break;
  case 'A': letoff=9-1;break;
  case 'B': letoff=11-1;break;
  }
  return 24+oct*12+letoff+bump;
}

int valid(int pitch,int string, int pos) {
  if (position[pitch][string]==-1) return -1;
  return fingering[pos][position[pitch][string]];
}

void init_pos(music *mus) {
  int i,j,k,f,done,a;
  for(i=0;i<mus->size;i++) {done=0;
    for(j=3;j>=0 && !done;j--)
      for(a=0,k=0;a<5;k=(k+1)%5,a++) {
	if ((f=valid(mus->data[i].pitch,j,k))!=-1) {
    mus->data[i].string=j;
    mus->data[i].pos=k;
    mus->data[i].finger=f;
    done=1;break;}}
  }
}

/*
void refine_pos(music *mus) {
  int a,b,i,c;
  for(a=3;a>=0;a--)
    for(b=0;b<5;b++) {
  for(i=0,c=0;i<mus->size-1;i++) {
    if (mus->data[i].string!=mus->data[i+1].string) c++;
    if (mus->data[i].pos!=mus->data[i+1].pos) c++;
  }

}
*/
